<?php
/**
 * InlineResponse20146ContentContentTicket
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20146ContentContentTicket Class Doc Comment
 *
 * @category Class
 * @description infos regarding a ticket which is stored as content in an tanss event
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20146ContentContentTicket implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_201_46_content_content_ticket';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'companyId' => 'int',
        'companyName' => 'string',
        'remitterId' => 'int',
        'remitterName' => 'string',
        'title' => 'string',
        'content' => 'string',
        'assignedToEmployeeId' => 'int',
        'assignedToEmployeeName' => 'string',
        'assignedToDepartmentId' => 'int',
        'assignedToDepartmentName' => 'string',
        'statusId' => 'int',
        'statusName' => 'string',
        'typeId' => 'int',
        'typeName' => 'string',
        'dueDate' => 'int',
        'dueDateFormatted' => 'string',
        'deadlineDate' => 'int',
        'deadlineDateFormatted' => 'string',
        'serviceCapAmount' => 'float',
        'serviceCapAmountFormatted' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'companyId' => null,
        'companyName' => null,
        'remitterId' => null,
        'remitterName' => null,
        'title' => null,
        'content' => null,
        'assignedToEmployeeId' => null,
        'assignedToEmployeeName' => null,
        'assignedToDepartmentId' => null,
        'assignedToDepartmentName' => null,
        'statusId' => null,
        'statusName' => null,
        'typeId' => null,
        'typeName' => null,
        'dueDate' => 'timestamp',
        'dueDateFormatted' => null,
        'deadlineDate' => 'timestamp',
        'deadlineDateFormatted' => null,
        'serviceCapAmount' => null,
        'serviceCapAmountFormatted' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'companyId' => 'companyId',
        'companyName' => 'companyName',
        'remitterId' => 'remitterId',
        'remitterName' => 'remitterName',
        'title' => 'title',
        'content' => 'content',
        'assignedToEmployeeId' => 'assignedToEmployeeId',
        'assignedToEmployeeName' => 'assignedToEmployeeName',
        'assignedToDepartmentId' => 'assignedToDepartmentId',
        'assignedToDepartmentName' => 'assignedToDepartmentName',
        'statusId' => 'statusId',
        'statusName' => 'statusName',
        'typeId' => 'typeId',
        'typeName' => 'typeName',
        'dueDate' => 'dueDate',
        'dueDateFormatted' => 'dueDateFormatted',
        'deadlineDate' => 'deadlineDate',
        'deadlineDateFormatted' => 'deadlineDateFormatted',
        'serviceCapAmount' => 'serviceCapAmount',
        'serviceCapAmountFormatted' => 'serviceCapAmountFormatted'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'companyId' => 'setCompanyId',
        'companyName' => 'setCompanyName',
        'remitterId' => 'setRemitterId',
        'remitterName' => 'setRemitterName',
        'title' => 'setTitle',
        'content' => 'setContent',
        'assignedToEmployeeId' => 'setAssignedToEmployeeId',
        'assignedToEmployeeName' => 'setAssignedToEmployeeName',
        'assignedToDepartmentId' => 'setAssignedToDepartmentId',
        'assignedToDepartmentName' => 'setAssignedToDepartmentName',
        'statusId' => 'setStatusId',
        'statusName' => 'setStatusName',
        'typeId' => 'setTypeId',
        'typeName' => 'setTypeName',
        'dueDate' => 'setDueDate',
        'dueDateFormatted' => 'setDueDateFormatted',
        'deadlineDate' => 'setDeadlineDate',
        'deadlineDateFormatted' => 'setDeadlineDateFormatted',
        'serviceCapAmount' => 'setServiceCapAmount',
        'serviceCapAmountFormatted' => 'setServiceCapAmountFormatted'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'companyId' => 'getCompanyId',
        'companyName' => 'getCompanyName',
        'remitterId' => 'getRemitterId',
        'remitterName' => 'getRemitterName',
        'title' => 'getTitle',
        'content' => 'getContent',
        'assignedToEmployeeId' => 'getAssignedToEmployeeId',
        'assignedToEmployeeName' => 'getAssignedToEmployeeName',
        'assignedToDepartmentId' => 'getAssignedToDepartmentId',
        'assignedToDepartmentName' => 'getAssignedToDepartmentName',
        'statusId' => 'getStatusId',
        'statusName' => 'getStatusName',
        'typeId' => 'getTypeId',
        'typeName' => 'getTypeName',
        'dueDate' => 'getDueDate',
        'dueDateFormatted' => 'getDueDateFormatted',
        'deadlineDate' => 'getDeadlineDate',
        'deadlineDateFormatted' => 'getDeadlineDateFormatted',
        'serviceCapAmount' => 'getServiceCapAmount',
        'serviceCapAmountFormatted' => 'getServiceCapAmountFormatted'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['companyId'] = $data['companyId'] ?? null;
        $this->container['companyName'] = $data['companyName'] ?? null;
        $this->container['remitterId'] = $data['remitterId'] ?? null;
        $this->container['remitterName'] = $data['remitterName'] ?? null;
        $this->container['title'] = $data['title'] ?? null;
        $this->container['content'] = $data['content'] ?? null;
        $this->container['assignedToEmployeeId'] = $data['assignedToEmployeeId'] ?? null;
        $this->container['assignedToEmployeeName'] = $data['assignedToEmployeeName'] ?? null;
        $this->container['assignedToDepartmentId'] = $data['assignedToDepartmentId'] ?? null;
        $this->container['assignedToDepartmentName'] = $data['assignedToDepartmentName'] ?? null;
        $this->container['statusId'] = $data['statusId'] ?? null;
        $this->container['statusName'] = $data['statusName'] ?? null;
        $this->container['typeId'] = $data['typeId'] ?? null;
        $this->container['typeName'] = $data['typeName'] ?? null;
        $this->container['dueDate'] = $data['dueDate'] ?? null;
        $this->container['dueDateFormatted'] = $data['dueDateFormatted'] ?? null;
        $this->container['deadlineDate'] = $data['deadlineDate'] ?? null;
        $this->container['deadlineDateFormatted'] = $data['deadlineDateFormatted'] ?? null;
        $this->container['serviceCapAmount'] = $data['serviceCapAmount'] ?? null;
        $this->container['serviceCapAmountFormatted'] = $data['serviceCapAmountFormatted'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id of the ticket
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets companyId
     *
     * @return int|null
     */
    public function getCompanyId()
    {
        return $this->container['companyId'];
    }

    /**
     * Sets companyId
     *
     * @param int|null $companyId id of the company of the ticket
     *
     * @return self
     */
    public function setCompanyId($companyId)
    {
        $this->container['companyId'] = $companyId;

        return $this;
    }

    /**
     * Gets companyName
     *
     * @return string|null
     */
    public function getCompanyName()
    {
        return $this->container['companyName'];
    }

    /**
     * Sets companyName
     *
     * @param string|null $companyName name of the company
     *
     * @return self
     */
    public function setCompanyName($companyName)
    {
        $this->container['companyName'] = $companyName;

        return $this;
    }

    /**
     * Gets remitterId
     *
     * @return int|null
     */
    public function getRemitterId()
    {
        return $this->container['remitterId'];
    }

    /**
     * Sets remitterId
     *
     * @param int|null $remitterId id of the remitter (employee id)
     *
     * @return self
     */
    public function setRemitterId($remitterId)
    {
        $this->container['remitterId'] = $remitterId;

        return $this;
    }

    /**
     * Gets remitterName
     *
     * @return string|null
     */
    public function getRemitterName()
    {
        return $this->container['remitterName'];
    }

    /**
     * Sets remitterName
     *
     * @param string|null $remitterName name of the remitter
     *
     * @return self
     */
    public function setRemitterName($remitterName)
    {
        $this->container['remitterName'] = $remitterName;

        return $this;
    }

    /**
     * Gets title
     *
     * @return string|null
     */
    public function getTitle()
    {
        return $this->container['title'];
    }

    /**
     * Sets title
     *
     * @param string|null $title title of the ticket
     *
     * @return self
     */
    public function setTitle($title)
    {
        $this->container['title'] = $title;

        return $this;
    }

    /**
     * Gets content
     *
     * @return string|null
     */
    public function getContent()
    {
        return $this->container['content'];
    }

    /**
     * Sets content
     *
     * @param string|null $content content of the ticket
     *
     * @return self
     */
    public function setContent($content)
    {
        $this->container['content'] = $content;

        return $this;
    }

    /**
     * Gets assignedToEmployeeId
     *
     * @return int|null
     */
    public function getAssignedToEmployeeId()
    {
        return $this->container['assignedToEmployeeId'];
    }

    /**
     * Sets assignedToEmployeeId
     *
     * @param int|null $assignedToEmployeeId id of the assigned employee
     *
     * @return self
     */
    public function setAssignedToEmployeeId($assignedToEmployeeId)
    {
        $this->container['assignedToEmployeeId'] = $assignedToEmployeeId;

        return $this;
    }

    /**
     * Gets assignedToEmployeeName
     *
     * @return string|null
     */
    public function getAssignedToEmployeeName()
    {
        return $this->container['assignedToEmployeeName'];
    }

    /**
     * Sets assignedToEmployeeName
     *
     * @param string|null $assignedToEmployeeName name of the assigned employee
     *
     * @return self
     */
    public function setAssignedToEmployeeName($assignedToEmployeeName)
    {
        $this->container['assignedToEmployeeName'] = $assignedToEmployeeName;

        return $this;
    }

    /**
     * Gets assignedToDepartmentId
     *
     * @return int|null
     */
    public function getAssignedToDepartmentId()
    {
        return $this->container['assignedToDepartmentId'];
    }

    /**
     * Sets assignedToDepartmentId
     *
     * @param int|null $assignedToDepartmentId id of the assigned department
     *
     * @return self
     */
    public function setAssignedToDepartmentId($assignedToDepartmentId)
    {
        $this->container['assignedToDepartmentId'] = $assignedToDepartmentId;

        return $this;
    }

    /**
     * Gets assignedToDepartmentName
     *
     * @return string|null
     */
    public function getAssignedToDepartmentName()
    {
        return $this->container['assignedToDepartmentName'];
    }

    /**
     * Sets assignedToDepartmentName
     *
     * @param string|null $assignedToDepartmentName name of the assigned department
     *
     * @return self
     */
    public function setAssignedToDepartmentName($assignedToDepartmentName)
    {
        $this->container['assignedToDepartmentName'] = $assignedToDepartmentName;

        return $this;
    }

    /**
     * Gets statusId
     *
     * @return int|null
     */
    public function getStatusId()
    {
        return $this->container['statusId'];
    }

    /**
     * Sets statusId
     *
     * @param int|null $statusId id of the ticket status
     *
     * @return self
     */
    public function setStatusId($statusId)
    {
        $this->container['statusId'] = $statusId;

        return $this;
    }

    /**
     * Gets statusName
     *
     * @return string|null
     */
    public function getStatusName()
    {
        return $this->container['statusName'];
    }

    /**
     * Sets statusName
     *
     * @param string|null $statusName name of the ticket status
     *
     * @return self
     */
    public function setStatusName($statusName)
    {
        $this->container['statusName'] = $statusName;

        return $this;
    }

    /**
     * Gets typeId
     *
     * @return int|null
     */
    public function getTypeId()
    {
        return $this->container['typeId'];
    }

    /**
     * Sets typeId
     *
     * @param int|null $typeId id of the ticket type
     *
     * @return self
     */
    public function setTypeId($typeId)
    {
        $this->container['typeId'] = $typeId;

        return $this;
    }

    /**
     * Gets typeName
     *
     * @return string|null
     */
    public function getTypeName()
    {
        return $this->container['typeName'];
    }

    /**
     * Sets typeName
     *
     * @param string|null $typeName name of the ticket type
     *
     * @return self
     */
    public function setTypeName($typeName)
    {
        $this->container['typeName'] = $typeName;

        return $this;
    }

    /**
     * Gets dueDate
     *
     * @return int|null
     */
    public function getDueDate()
    {
        return $this->container['dueDate'];
    }

    /**
     * Sets dueDate
     *
     * @param int|null $dueDate due date as timestamp
     *
     * @return self
     */
    public function setDueDate($dueDate)
    {
        $this->container['dueDate'] = $dueDate;

        return $this;
    }

    /**
     * Gets dueDateFormatted
     *
     * @return string|null
     */
    public function getDueDateFormatted()
    {
        return $this->container['dueDateFormatted'];
    }

    /**
     * Sets dueDateFormatted
     *
     * @param string|null $dueDateFormatted formatted due date
     *
     * @return self
     */
    public function setDueDateFormatted($dueDateFormatted)
    {
        $this->container['dueDateFormatted'] = $dueDateFormatted;

        return $this;
    }

    /**
     * Gets deadlineDate
     *
     * @return int|null
     */
    public function getDeadlineDate()
    {
        return $this->container['deadlineDate'];
    }

    /**
     * Sets deadlineDate
     *
     * @param int|null $deadlineDate deadline date as timestamp
     *
     * @return self
     */
    public function setDeadlineDate($deadlineDate)
    {
        $this->container['deadlineDate'] = $deadlineDate;

        return $this;
    }

    /**
     * Gets deadlineDateFormatted
     *
     * @return string|null
     */
    public function getDeadlineDateFormatted()
    {
        return $this->container['deadlineDateFormatted'];
    }

    /**
     * Sets deadlineDateFormatted
     *
     * @param string|null $deadlineDateFormatted formatted deadline date
     *
     * @return self
     */
    public function setDeadlineDateFormatted($deadlineDateFormatted)
    {
        $this->container['deadlineDateFormatted'] = $deadlineDateFormatted;

        return $this;
    }

    /**
     * Gets serviceCapAmount
     *
     * @return float|null
     */
    public function getServiceCapAmount()
    {
        return $this->container['serviceCapAmount'];
    }

    /**
     * Sets serviceCapAmount
     *
     * @param float|null $serviceCapAmount service cap of the ticket
     *
     * @return self
     */
    public function setServiceCapAmount($serviceCapAmount)
    {
        $this->container['serviceCapAmount'] = $serviceCapAmount;

        return $this;
    }

    /**
     * Gets serviceCapAmountFormatted
     *
     * @return string|null
     */
    public function getServiceCapAmountFormatted()
    {
        return $this->container['serviceCapAmountFormatted'];
    }

    /**
     * Sets serviceCapAmountFormatted
     *
     * @param string|null $serviceCapAmountFormatted formatted service cap
     *
     * @return self
     */
    public function setServiceCapAmountFormatted($serviceCapAmountFormatted)
    {
        $this->container['serviceCapAmountFormatted'] = $serviceCapAmountFormatted;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


